unit Unit2;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls;

type
  TNotifyClose = procedure; stdcall;

type
  TForm2 = class(TForm)
    Label1: TLabel;
    procedure FormDestroy(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
  private
    { Private declarations }
  public
    { Public declarations }
    FNC: TNotifyClose;
  end;

var
  Form2: TForm2;

procedure DynNonmodal(AppHandle:THandle; NC: Pointer); stdcall;

implementation

{$R *.dfm}


procedure TForm2.FormDestroy(Sender: TObject);
begin
  if Assigned(FNC) then FNC;
end;

procedure TForm2.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  Action := caFree;
end;

procedure DynNonmodal(AppHandle:THandle; NC: Pointer); stdcall;
begin
  Application.Handle:=AppHandle;
  if Assigned(Form2) then
    Form2.Show
  else begin
    Form2:=TForm2.Create(Application);
    Form2.FNC:= TNotifyClose(NC);
    Form2.Show;
  end;
end;

end.
